<template>
  <!-- Input Dialog -->
  <q-dialog v-model="inputDialog" :maximized="true">
    <q-card>
      <q-card-section class="row items-center q-pb-none">
        <div class="text-h5">{{ title }}</div>
        <q-space></q-space>
        <q-btn dense flat v-close-popup>
          <q-icon name="close"></q-icon>
        </q-btn>
      </q-card-section>
      <q-card-section class="q-gutter-md">
        <q-input label="Username" v-model="data.username" />
        <q-input label="E-Mail" v-model="data.email" />
        <q-input label="Password" v-model="data.password" />
        <q-select
          label="Role"
          v-model="data.role"
          :options="['admin', 'member']"
        />
        <q-btn color="green" v-close-popup @click="saveData">Simpan</q-btn>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- Delete Dialog -->
  <q-dialog v-model="deleteDialog">
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="delete" color="red" text-color="white" />
        <span class="q-ml-sm"> Yakin ingin hapus? </span>
      </q-card-section>
      <q-card-actions align="right">
        <q-btn flat label="Batal" color="primary" v-close-popup />
        <q-btn
          flat
          label="Hapus"
          color="primary"
          v-close-popup
          @click="deleteItem"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <!-- Actual Page -->
  <admin-page-template
    title="User Management"
    :breadcrumbs="['Dashboard', 'User']"
  >
    <q-table
      :title="title"
      :rows="store.items"
      row-key="id"
      :columns="[
        {
          name: 'username',
          field: 'username',
          align: 'left',
          label: 'Username',
        },
        {
          name: 'email',
          field: 'email',
          align: 'left',
          label: 'E-Mail',
        },
        {
          name: 'role',
          field: 'role',
          align: 'left',
          label: 'Role',
        },
        {
          name: 'option',
          align: 'right',
          label: 'Option',
        },
      ]"
    >
      <template v-slot:top-right>
        <q-btn
          color="primary"
          :label="'+ ' + title"
          @click="openInputDialog()"
        />
      </template>
      <template v-slot:body-cell-option="props">
        <q-td :props="props">
          <div>
            <q-btn flat @click="openInputDialog(props.row)">
              <q-icon name="edit" color="blue"></q-icon>
            </q-btn>
            <q-btn flat @click="openDeleteDialog(props.row)">
              <q-icon name="delete" color="red"></q-icon>
            </q-btn>
          </div>
        </q-td>
      </template>
    </q-table>
  </admin-page-template>
</template>

<script>
import { ref } from 'vue';
import { useAdminUsersStore } from 'src/stores/admin-users';
import { generateCommonDialogState } from './_stateGenerator';
import AdminPageTemplate from 'src/components/AdminPageTemplate.vue';

export default {
  name: 'UserAdminPage',

  components: { AdminPageTemplate },
  setup() {
    const title = 'User';
    const data = ref({
      id: 0,
      username: '',
      password: '',
      email: '',
      role: 'member',
    });
    const store = useAdminUsersStore();
    store.fetchItems();

    return {
      store,
      title,
      data,
      ...generateCommonDialogState(data, store),
    };
  },
};
</script>
